﻿//-----------------------------------------------
//TUSB-0212ADMH用ドライバアクセス用API
//Visual C# 用モジュール
//
//2013_12_10　株式会社タートル工業
//Copyright (C) 2013 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;

class TUSBADMH
{
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Device_Open( short id);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbadmh_Device_Close( short id);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Dio_Read( short id, out byte Data);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Dio_Write( short id, byte Data);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Adc_Start( short id, int CycLen, int PreLen, byte TrgSel, byte Mode, byte Ch1Only );
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Adc_Stop( short id);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Status_Get( short id, out byte Status, out byte OvfSt);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Length( short id, out int Len1, out int Len2, out int Rate1, out int Rate2);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Data_Get( short id, byte ch, [Out] int[] Data, ref int Leng);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Clock_Select( short id, byte ClkSel, byte Div, byte Ave);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_ThLevel_Set( short id, int ThLevel, int NLevel);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_InputType( short id, byte Type1, byte Type2);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_CheckInputType( short id, out byte Type1, out byte Type2);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_Trigger(short id);
    [DllImport("TUSBADMH.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadmh_TransLimit(short id, int Limit);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            case 10:
                return "メモリ領域が確保できません";
            case 11:
                return "連続取込動作中です";
            case 12:
                return "連続取り込みデータはありません";
            case 13:
                return "開始されていません";
            case 14:
                return "メモリオーバーフロー";
            case 15:
                return "データ並びエラー";
            default:
                return "不明なエラーです";
        }
    }
}