﻿Imports System.IO

Public Class DevForm
    Private DevId As Short 'Device Id

    Private SmplMaxLeng As Integer '最大取り込み長
    Private SaveFile(1) As BinaryWriter '保存ファイルストリーム
    Private SavedDataNum(1) As Integer
    'サンプリング条件----------------------------------
    Private ClkSrc As Byte 'クロック源設定 0:200MHz 1:20.48MHz 2:16.384MHz 3:12.8MHz 4:1.92MHz 5:Ext
    Private ClkDivN As Byte 'クロック分周率
    Private SmplAve As Byte 'サンプリング平均化設定 2^n

    Private TrgSel As Byte 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
    Private Threshold As Integer 'アナログトリガ閾値
    Private NoiseCancel As Integer 'ノイズキャンセルレベル

    '自然数かどうか判定する関数
    Private Function IsNatural(ByRef strNum As String) As Boolean
        If System.Text.RegularExpressions.Regex.IsMatch(strNum, "^[1-9]\d{0,8}$") Then 'Charactor check [0-9]
            Return True
        Else
            Return False
        End If
    End Function

    '自然数かどうか判定する関数(0を含む)
    Private Function IsNatural0(ByRef strNum As String) As Boolean
        If System.Text.RegularExpressions.Regex.IsMatch(strNum, "^\d{1,9}$") Then 'Charactor check [0-9]
            Return True
        Else
            Return False
        End If
    End Function

    'DevFormの初期化を行う
    Public Sub SetId(ByVal Id As Short)
        Dim retErr As Short 'return error
        Dim IOData As Byte '
        Dim Type1 As Byte
        Dim Type2 As Byte

        DevId = Id

        Me.Text = "ID = " & CStr(DevId) & "  Panel"
        retErr = Tusbadmh_Dio_Read(DevId, IOData) 'Read digital I/O
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        Else
            'Output state
            DOChk3.CheckState = IIf(IOData And &H80S, 1, 0)
            DOChk2.CheckState = IIf(IOData And &H40S, 1, 0)
            DOChk1.CheckState = IIf(IOData And &H20S, 1, 0)
            DOChk0.CheckState = IIf(IOData And &H10S, 1, 0)

            'Input State
            DIDisp3.Text = IIf(IOData And &H8S, "High", "Low")
            DIDisp2.Text = IIf(IOData And &H4S, "High", "Low")
            DIDisp1.Text = IIf(IOData And &H2S, "High", "Low")
            DIDisp0.Text = IIf(IOData And &H1S, "High", "Low")
        End If

        DivideN.Text = CStr(2)
        Check_ClockSetting()

        retErr = Tusbadmh_CheckInputType(DevId, Type1, Type2) 'Read input range
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        Else
            If Type1 Then
                Ch1InputSel1.Checked = True
            Else
                Ch1InputSel2.Checked = True
            End If
            If Type1 Then
                Ch2InputSel1.Checked = True
            Else
                Ch2InputSel2.Checked = True
            End If
        End If
        retErr = Tusbadmh_TransLimit(DevId, 50000)
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
        End If

        TrgSel4.Checked = True 'Select soft trigger
        TrgSet()
        ThLevel.Text = "32768" 'Select center of range
        NCLevel.Text = "1638" '50mV
        SmplMode2.Checked = True 'Continuation mode
        CycleLeng.Text = "1000" 'Sampling length per one trigger. (1～1,048,576)
        PreTrgLeng.Text = "0" 'Pre trigger length. (0～1,048,576)
        TotalLeng.Text = "100000" 'Total sampling length.  (1～2,000,000,000)
        ClockSrc.SelectedIndex = 0 '200MHz
        DivideN.Text = "8" 'divide 8 ( 200MHz / 8 -> 25MHz )
        AverageN.SelectedIndex = 0 'Average 1


        Timer1.Interval = 100
        Timer1.Enabled = True
    End Sub

    'ディジタル出力設定
    Private Sub DO_Set()
        Dim retErr As Short
        Dim OutData As Byte

        OutData = 0

        If DOChk0.CheckState Then 'ビット0
            OutData = OutData + &H1S
        End If
        If DOChk1.CheckState Then 'ビット1
            OutData = OutData + &H2S
        End If
        If DOChk2.CheckState Then 'ビット2
            OutData = OutData + &H4S
        End If
        If DOChk3.CheckState Then 'ビット3
            OutData = OutData + &H8S
        End If

        retErr = Tusbadmh_Dio_Write(DevId, OutData) '設定
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        End If
    End Sub

    Private Sub DOChk_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles DOChk3.CheckedChanged, DOChk2.CheckedChanged, DOChk1.CheckedChanged, DOChk0.CheckedChanged
        DO_Set()
        DOChk0.Text = IIf(DOChk0.Checked, "High", "Low")
        DOChk1.Text = IIf(DOChk1.Checked, "High", "Low")
        DOChk2.Text = IIf(DOChk2.Checked, "High", "Low")
        DOChk3.Text = IIf(DOChk3.Checked, "High", "Low")
    End Sub

    'クロック設定条件の確認
    Private Sub Check_ClockSetting()
        Dim tmpClk As Double
        Dim tmpDivN As Double
        Dim tmpInt As Integer

        If ClockSrc.SelectedIndex < 0 Then
            Exit Sub
        End If

        ClkSrc = ClockSrc.SelectedIndex

        If ClkSrc = 5 Then
            IntClockFreq.Text = ""
            Exit Sub
        End If

        Select Case ClkSrc
            Case 0 '200MHz
                tmpClk = 200.0#
            Case 1 '20.48MHz
                tmpClk = 20.48
            Case 2 '16.384MHz
                tmpClk = 16.384
            Case 3 '12.8MHz
                tmpClk = 12.8
            Case 4 '1.92MHz
                tmpClk = 1.92
        End Select

        If IsNatural((DivideN.Text)) Then '分周率入力が数値か
            Integer.TryParse(DivideN.Text, tmpInt) '分周率を得る
            If tmpInt <> 0 Then '分周率が0でないこと
                tmpClk /= tmpInt
                If tmpClk > 25.0# Or tmpClk < 1.0# Then 'クロックは1～25MHzでなければならない
                    IntClockFreq.Text = "Out of Range"
                    Exit Sub
                End If
                ClkDivN = CByte(tmpInt)
            Else
                IntClockFreq.Text = "Invalid value"
                Exit Sub
            End If
        Else
            IntClockFreq.Text = "Invalid value"
            Exit Sub
        End If

        If AverageN.SelectedIndex < 0 Then
            Exit Sub
        End If

        SmplAve = AverageN.SelectedIndex
        Double.TryParse(AverageN.Text, tmpDivN)
        tmpClk = tmpClk / tmpDivN
        If tmpClk >= 1.0# Then
            IntClockFreq.Text = tmpClk.ToString("0.0000") & "MHz"
        Else
            IntClockFreq.Text = (tmpClk * 1000.0).ToString("0.0000") & "kHz"
        End If
    End Sub

    Private Sub ClockSrc_TextChanged(sender As System.Object, e As System.EventArgs) Handles ClockSrc.TextChanged
        Check_ClockSetting()
    End Sub

    Private Sub ClockSrc_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ClockSrc.SelectedIndexChanged
        Check_ClockSetting()
    End Sub

    Private Sub DivideN_TextChanged(sender As System.Object, e As System.EventArgs) Handles DivideN.TextChanged
        Check_ClockSetting()
    End Sub

    '入力レンジ選択
    Private Sub SetInputType()
        Dim retErr As Short
        Dim Type1 As Byte
        Dim Type2 As Byte

        Type1 = IIf(Ch1InputSel1.Checked, 1, 0) 'ch1 0:unipolar 1:bipolar
        Type2 = IIf(Ch2InputSel1.Checked, 1, 0) 'ch2 0:unipolar 1:bipolar

        retErr = Tusbadmh_InputType(DevId, Type1, Type2) 'Set input range
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        End If
    End Sub

    Private Sub AverageN_TextChanged(sender As System.Object, e As System.EventArgs) Handles AverageN.TextChanged
        Check_ClockSetting()
    End Sub

    Private Sub AverageN_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles AverageN.SelectedIndexChanged
        Check_ClockSetting()
    End Sub

    Private Sub Ch1InputSel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Ch1InputSel1.CheckedChanged, Ch1InputSel2.CheckedChanged
        SetInputType()
        ThLevelChange()
    End Sub

    Private Sub Ch2InputSel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Ch2InputSel1.CheckedChanged, Ch2InputSel2.CheckedChanged
        SetInputType()
    End Sub

    'ディジタル入力チェック
    Private Sub DI_Check()
        Dim IOData As Byte
        Dim retErr As Short

        retErr = Tusbadmh_Dio_Read(DevId, IOData)
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        Else
            '入力状態
            DIDisp3.Text = IIf(IOData And &H8S, "High", "Low") 'ビット3
            DIDisp2.Text = IIf(IOData And &H4S, "High", "Low") 'ビット2
            DIDisp1.Text = IIf(IOData And &H2S, "High", "Low") 'ビット1
            DIDisp0.Text = IIf(IOData And &H1S, "High", "Low") 'ビット0
        End If
    End Sub

    Private Sub FileConvBtn_Click(sender As System.Object, e As System.EventArgs) Handles FileConvBtn.Click
        Dim ReadFileName As String
        Dim WriteFileName As String
        Dim ReadFile As BinaryReader '読み出しファイルストリーム
        Dim WriteFile As StreamWriter ' 保存ファイルストリーム

        Do
            OpenFileDialog1.FileName = ""
            OpenFileDialog1.Title = "バイナリファイル指定"
            OpenFileDialog1.Filter = "バイナリファイル (*.dat)|*.dat"
            If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                Exit Sub
            End If
        Loop While OpenFileDialog1.FileName = ""
        ReadFileName = OpenFileDialog1.FileName

        Do
            SaveFileDialog1.OverwritePrompt = True
            SaveFileDialog1.FileName = ""
            SaveFileDialog1.Title = "変換先ファイル指定"
            SaveFileDialog1.Filter = "テキスト保存ファイル (*.csv)|*.csv"

            If (SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                Exit Sub
            End If
        Loop While SaveFileDialog1.FileName = ""
        WriteFileName = SaveFileDialog1.FileName

        ReadFile = New BinaryReader(File.OpenRead(ReadFileName)) 'ファイルを開く
        If File.Exists(SaveFileDialog1.FileName) Then '既存ファイルチェック
            File.Delete(SaveFileDialog1.FileName)
        End If
        WriteFile = New StreamWriter(File.OpenWrite(WriteFileName)) 'ファイルを開く

        WriteFile.WriteLine("Start date time" & "," & System.DateTime.FromBinary(ReadFile.ReadInt64()).ToString()) '日時
        WriteFile.WriteLine("Channel" & "," & ReadFile.ReadByte().ToString()) 'ch
        WriteFile.WriteLine("Clock select" & "," & Choose(ReadFile.ReadByte() + 1, "200MHz", "20.48MHz", "16.384MHz", "12.8MHz", "1.92MHz", "External")) 'クロック源
        WriteFile.WriteLine("Dividing rate" & "," & ReadFile.ReadByte().ToString()) 'クロック分周率
        WriteFile.WriteLine("Average Cnt" & "," & (2 ^ ReadFile.ReadByte()).ToString()) 'サンプリング平均化乗数
        WriteFile.WriteLine("Input range" & "," & IIf(ReadFile.ReadByte() = 0, "Unipolar", "Bipolar")) 'レンジ 0:ユニポーラ　1:バイポーラ
        WriteFile.WriteLine("Clock select" & "," & Choose(ReadFile.ReadByte() + 1, "External", "Up edge", "Down edge", "Software")) 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
        WriteFile.WriteLine("Trigger threshold" & "," & ReadFile.ReadInt32().ToString()) 'アナログトリガ閾値
        WriteFile.WriteLine("Noise cancel level" & "," & ReadFile.ReadInt32().ToString()) 'ノイズキャンセルレベル
        WriteFile.WriteLine("Sampling mode" & "," & IIf(ReadFile.ReadByte() = 0, "Continuation", "Repeat")) '取り込み動作モード 0:連続 1:リピート
        WriteFile.WriteLine("Sampling length per one trigger" & "," & ReadFile.ReadInt32().ToString()) '1トリガ当たりの取り込み長
        WriteFile.WriteLine("Pre trigger length" & "," & ReadFile.ReadInt32().ToString()) 'プレトリガ長

        Try
            Do
                WriteFile.WriteLine(ReadFile.ReadInt32() And &HFFFF)
            Loop
        Catch ex As EndOfStreamException
            If Not (TypeOf ex Is EndOfStreamException) Then
                MessageBox.Show(ex.ToString())
            End If
        End Try

        ReadFile.Close()
        WriteFile.Close()

        MessageBox.Show("変換が終了しました")
    End Sub

    Private Sub DevForm_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If Timer2.Enabled Then 'タイマー2が動作中であれば
            Timer2.Enabled = False
            StartStop()
        End If
        Timer1.Enabled = False 'タイマー1を停止します
    End Sub

    'ノイズキャンセルレベル設定値のチェック
    Private Sub NCLevel_TextChanged(sender As System.Object, e As System.EventArgs) Handles NCLevel.TextChanged
        Dim Level As Integer
        Dim Volt As Double

        If IsNatural0((NCLevel.Text)) Then '自然数であるか
            Integer.TryParse(NCLevel.Text, Level)
            If (Level >= 0 And Level <= 3277) Then '範囲内であるか
                Volt = 2.0# * Level / 65536.0# * 1000.0#
                NCLevelV.Text = Volt.ToString("0.0") & "[mV]"
            Else
                NCLevelV.Text = ""
            End If
        Else
            NCLevelV.Text = ""
        End If
    End Sub

    Private Sub SmplMode_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles SmplMode1.CheckedChanged, SmplMode2.CheckedChanged
        If SmplMode1.Checked Then
            CycleLeng.Enabled = True
            PreTrgLeng.Enabled = False
        ElseIf SmplMode2.Checked Then
            CycleLeng.Enabled = False
            PreTrgLeng.Enabled = True
        End If
    End Sub

    'クロック設定値のチェックと設定
    Private Function ClockCheckAndSet() As Boolean
        Dim retErr As Short
        Dim tmpClk As Double
        Dim tmpInt As Integer

        ClkSrc = ClockSrc.SelectedIndex

        If ClkSrc <> 5 Then '内部クロック
            Select Case ClkSrc
                Case 0 '200MHz
                    tmpClk = 200.0#
                Case 1 '20.48MHz
                    tmpClk = 20.48
                Case 2 '16.384MHz
                    tmpClk = 16.384
                Case 3 '12.8MHz
                    tmpClk = 12.8
                Case 4 '1.92MHz
                    tmpClk = 1.92
            End Select

            If IsNatural((DivideN.Text)) Then 'クロック分周率が自然数がどうか
                Integer.TryParse(DivideN.Text, tmpInt)
                If tmpInt <> 0 Then '分周率が0でないこと
                    tmpClk /= tmpInt
                    If tmpClk > 25.0# Or tmpClk < 1.0# Then 'クロックは1～25MHzでなければならない
                        MessageBox.Show("クロック設定範囲(1～25MHz)です")
                        Return False
                    End If
                    ClkDivN = CByte(tmpInt)
                Else
                    MessageBox.Show("分周率が不正です")
                    Return False
                End If
            Else
                MessageBox.Show("クロック入力の形式が不正です")
                Return False
            End If
        Else '外部クロック
            If IsNatural((DivideN.Text)) Then 'クロック分周率が自然数がどうか
                Integer.TryParse(DivideN.Text, tmpInt)
                If (tmpInt < 1 Or tmpInt > 25) Then
                    MessageBox.Show("分周比が不正です")
                    Return False
                End If
                ClkDivN = CByte(tmpInt)
            Else
                MessageBox.Show("クロック入力の形式が不正です")
                Return False
            End If
        End If

        SmplAve = AverageN.SelectedIndex

        retErr = Tusbadmh_Clock_Select(DevId, ClkSrc, ClkDivN - 1, SmplAve) 'クロック設定
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Return False
        End If

        Return True

    End Function

    'トリガ条件チェックと設定
    Private Function TriggerCheckAndSet() As Boolean
        Dim retErr As Short

        If TrgSel2.Checked Or TrgSel3.Checked Then 'アナログトリガの場合
            If IsNatural((ThLevel.Text)) Then 'トリガレベルが自然数であるか
                Integer.TryParse(ThLevel.Text, Threshold)
                If (Threshold < 1 Or Threshold > 65534) Then '範囲の確認
                    MessageBox.Show("アナログトリガレベル設定範囲が正しくありません")
                    Return False
                End If
            Else
                MessageBox.Show("アナログトリガレベル設定値が不正です")
                Return False
            End If

            If IsNatural0((NCLevel.Text)) Then 'ノイズキャンセルレベルが自然数であるか
                Integer.TryParse(NCLevel.Text, NoiseCancel)
                If (NoiseCancel < 0 Or NoiseCancel > 3277) Then '範囲の確認
                    MessageBox.Show("ノイズキャンセル設定範囲が正しくありません")
                    Return False
                End If
            Else
                MessageBox.Show("ノイズキャンセル設定値が不正です")
                Return False
            End If

            retErr = Tusbadmh_ThLevel_Set(DevId, Threshold, NoiseCancel) 'スレッショルドレベル設定
            If retErr <> 0 Then
                Tusbadmh_ErrorDisp(retErr)
                Me.Hide()
                Return False
            End If
        Else
        End If

        Return True
    End Function

    Private Sub SaveSamplingSettings(CycLen As Integer, PreLen As Integer, Mode As Byte)
        Dim startTime As System.DateTime '日時
        Dim Type1 As Byte 'ch1 1:ユニポーラ　0:バイポーラ
        Dim Type2 As Byte 'ch2 1:ユニポーラ　0:バイポーラ
        Dim InCh As Byte '入力チャンネル
        startTime = System.DateTime.Now
        Type1 = IIf(Ch1InputSel1.Checked, 1, 0)
        Type2 = IIf(Ch2InputSel1.Checked, 1, 0)

        InCh = 1 'チャンネル1
        SaveFile(0).Write(startTime.ToBinary()) '現在日時
        SaveFile(0).Write(InCh) 'チャンネル1
        SaveFile(0).Write(ClkSrc) 'クロック源
        SaveFile(0).Write(ClkDivN) '内部クロック分周率
        SaveFile(0).Write(SmplAve) 'サンプリング平均化
        SaveFile(0).Write(Type1) 'ch1 0:ユニポーラ　1:バイポーラ
        SaveFile(0).Write(TrgSel) 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
        SaveFile(0).Write(Threshold) 'アナログトリガ閾値
        SaveFile(0).Write(NoiseCancel) 'ノイズキャンセルレベル
        SaveFile(0).Write(Mode) '取り込み動作モード 0:連続 1:リピート
        SaveFile(0).Write(CycLen) '1トリガ当たりの取り込み長
        SaveFile(0).Write(PreLen) 'プレトリガ長

        If Ch1Only.CheckState = 0 Then
            InCh = 2 'チャンネル2
            SaveFile(1).Write(startTime.ToBinary()) '現在日時
            SaveFile(1).Write(InCh) 'チャンネル2
            SaveFile(1).Write(ClkSrc) 'クロック源
            SaveFile(1).Write(ClkDivN) '内部クロック分周率
            SaveFile(1).Write(SmplAve) 'サンプリング平均化
            SaveFile(1).Write(Type2) 'ch2 0:ユニポーラ　1:バイポーラ
            SaveFile(1).Write(TrgSel) 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
            SaveFile(1).Write(Threshold) 'アナログトリガ閾値
            SaveFile(1).Write(NoiseCancel) 'ノイズキャンセルレベル
            SaveFile(1).Write(Mode) '取り込み動作モード 0:連続 1:リピート
            SaveFile(1).Write(CycLen) '1トリガ当たりの取り込み長
            SaveFile(1).Write(PreLen) 'プレトリガ長
        End If
    End Sub
    '連続変換開始
    Private Function SamplingStart() As Boolean
        Dim retErr As Short
        Dim CycLen As Integer
        Dim PreLen As Integer
        Dim Mode As Byte

        'クロック設定チェック
        If ClockCheckAndSet() = False Then
            Return False
        End If

        'トリガ設定チェック
        If TriggerCheckAndSet() = False Then
            Return False
        End If

        '取り込み数チェック
        If SmplMode1.Checked Then 'リピートモード
            If IsNatural((CycleLeng.Text)) Then
                Integer.TryParse(CycleLeng.Text, CycLen)
                If (CycLen < 1 Or CycLen > 1048576) Then
                    MessageBox.Show("1トリガ当たりの取り込み長が範囲外です")
                    Return False
                End If
            Else
                MessageBox.Show("1トリガ当たりの取り込み長入力が不正です")
                Return False
            End If
            PreLen = 0
            Mode = 1
        Else '連続モード
            If IsNatural0((PreTrgLeng.Text)) Then
                Integer.TryParse(PreTrgLeng.Text, PreLen)
                If (PreLen < 0 Or PreLen > 1048576) Then
                    MessageBox.Show("プレトリガ長が範囲外です")
                    Return False
                End If
            Else
                MessageBox.Show("プレトリガ長入力が不正です")
                Return False
            End If
            CycLen = 1
            Mode = 0
        End If
        If IsNatural((TotalLeng.Text)) Then
            Integer.TryParse(TotalLeng.Text, SmplMaxLeng)
            If (SmplMaxLeng < 1 Or SmplMaxLeng > 2000000000) Then
                MessageBox.Show("最大取り込み長が範囲外です")
                Return False
            End If
        Else
            MessageBox.Show("最大取り込み長入力が不正です")
            Return False
        End If

        'トリガ選択
        If TrgSel1.Checked Then
            TrgSel = 0
        ElseIf TrgSel2.Checked Then
            TrgSel = 1
        ElseIf TrgSel3.Checked Then
            TrgSel = 2
        Else
            TrgSel = 3
        End If

        '保存ファイルオープン
        Dim FileName(1) As String

        SaveFileDialog1.FileName = ""
        SaveFileDialog1.Title = "ADM Ch1 保存ファイル指定"
        SaveFileDialog1.Filter = "バイナリ保存ファイル (*.dat)|*.dat"
        If SaveFileDialog1.ShowDialog() <> DialogResult.OK Then
            Return False
        End If
        FileName(0) = SaveFileDialog1.FileName
        If Dir(FileName(0)) <> "" Then
            Kill(FileName(0))
        End If
        SaveFile(0) = New BinaryWriter(File.OpenWrite(FileName(0))) 'ファイルを開く

        If Ch1Only.CheckState = 0 Then
            SaveFileDialog1.FileName = ""
            SaveFileDialog1.Title = "ADM Ch2 保存ファイル指定"
            SaveFileDialog1.Filter = "バイナリ保存ファイル (*.dat)|*.dat"
            If SaveFileDialog1.ShowDialog() <> DialogResult.OK Then
                Return False
            End If
            FileName(1) = SaveFileDialog1.FileName
            If Dir(FileName(1)) <> "" Then
                Kill(FileName(1))
            End If
            SaveFile(1) = New BinaryWriter(File.OpenWrite(FileName(1))) 'ファイルを開く
        End If

        '取り込み設定情報書き込み
        SaveSamplingSettings(CycLen, PreLen, Mode)

        '変換開始
        Dim Ch1OnlyFlg As Byte
        Ch1OnlyFlg = IIf(Ch1Only.CheckState, 1, 0)
        retErr = Tusbadmh_Adc_Start(DevId, CycLen, PreLen, TrgSel, Mode, Ch1OnlyFlg) '変換開始
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Return False
        End If

        SavedDataNum(0) = 0
        SavedDataNum(1) = 0
        Timer2.Interval = 200
        Timer2.Enabled = True
        Return True
    End Function

    '変換停止
    Private Function SamplingStop() As Boolean
        Dim retErr As Short

        '変換終了
        Timer2.Enabled = False

        retErr = Tusbadmh_Adc_Stop(DevId) '停止

        SaveFile(0).Close()
        SaveFile(1).Close()

        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Return False
        End If
        Return True
    End Function

    'パネル上のコントロールの有効、無効の設定
    Private Sub EnableDisableControl(ByRef Enable As Boolean)
        ClockSrc.Enabled = Enable
        AverageN.Enabled = Enable
        DivideN.Enabled = Enable
        Ch1InputSel1.Enabled = Enable
        Ch1InputSel2.Enabled = Enable
        Ch2InputSel1.Enabled = Enable
        Ch2InputSel2.Enabled = Enable
        TrgSel1.Enabled = Enable
        TrgSel2.Enabled = Enable
        TrgSel3.Enabled = Enable
        TrgSel4.Enabled = Enable
        ThLevel.Enabled = Enable
        NCLevel.Enabled = Enable
        SmplMode1.Enabled = Enable
        SmplMode2.Enabled = Enable
        TotalLeng.Enabled = Enable
        FileConvBtn.Enabled = Enable
        Ch1Only.Enabled = Enable

        If SmplMode1.Checked Then '繰り返しモード
            CycleLeng.Enabled = Enable
            PreTrgLeng.Enabled = False
        Else '連続モード
            CycleLeng.Enabled = False
            PreTrgLeng.Enabled = Enable
        End If
    End Sub

    '変換開始、停止ボタン押下
    Private Sub StartStop()
        Dim CurPath As String

        If StartStopBtn.Text = "Start" Then '開始の場合
            CurPath = System.IO.Path.GetDirectoryName(Application.ExecutablePath)
            If SamplingStart() Then
                EnableDisableControl(False)
                StartStopBtn.Text = "Stop"
            End If
            ChDir((CurPath))
        Else '停止の場合
            If SamplingStop() Then
                EnableDisableControl(True)
                StartStopBtn.Text = "Start"
                StatusText.Text = ""
            End If
        End If
    End Sub

    Private Sub StartStopBtn_Click(sender As System.Object, e As System.EventArgs) Handles StartStopBtn.Click
        StartStop()
    End Sub

    'トリガスレッショルドレベルが変わった時の処理
    Private Sub ThLevelChange()
        Dim Level As Integer
        Dim Volt As Double

        If IsNatural((ThLevel.Text)) Then
            Integer.TryParse(ThLevel.Text, Level)
            If (Level >= 1 And Level <= 65534) Then
                If Ch1InputSel1.Checked Then 'ユニポーラ 0-2V
                    Volt = 2.0# * Level / 65536.0#
                Else 'バイポーラ
                    Volt = 2.0# * Level / 65536.0# - 1.0#
                End If
                ThLevelV.Text = Volt.ToString("0.000") & "[V]"
            Else
                ThLevelV.Text = ""
            End If
        Else
            ThLevelV.Text = ""
        End If
    End Sub

    Private Sub ThLevel_TextChanged(sender As System.Object, e As System.EventArgs) Handles ThLevel.TextChanged
        ThLevelChange()
    End Sub

    ' タイマー1処理
    ' 接続状況の監視などを行う
    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        DI_Check()
    End Sub

    'タイマー2の処理
    '変換時の監視
    Private Sub Timer2_Tick(sender As System.Object, e As System.EventArgs) Handles Timer2.Tick
        Dim Status As Byte
        Dim OvfSt As Byte
        Dim Leng(1) As Integer
        Dim UsableRate(1) As Integer
        Dim Data() As Integer
        Dim cnt As Integer

        'ステータスチェック
        If Tusbadmh_Status_Get(DevId, Status, OvfSt) = 0 Then
            Select Case Status
                Case 0 '停止
                    StatusText.Text = ""
                Case 1 'トリガ前
                    StatusText.Text = "Trigger waiting."
                Case 2 'トリガ後
                    Select Case OvfSt
                        Case 1 'ch1オーバフロー
                            StatusText.Text = "Ch1 buffer overflow."
                        Case 2 'ch2オーバフロー
                            StatusText.Text = "Ch2 buffer overflow."
                        Case 3 'ch1とCh2オーバフロー
                            StatusText.Text = "Ch1 && Ch2 buffer overflow."
                        Case Else
                            StatusText.Text = "Sampling"
                    End Select
            End Select
        End If

        'データ取り込み
        If Tusbadmh_Length(DevId, Leng(0), Leng(1), UsableRate(0), UsableRate(1)) = 0 Then

            If (SavedDataNum(0) + Leng(0)) > SmplMaxLeng Then 'Ch1 データが多すぎる場合
                Leng(0) = SmplMaxLeng - SavedDataNum(0)
            End If
            If Leng(0) Then
                ReDim Data(Leng(0) - 1)
                If Tusbadmh_Data_Get(DevId, 0, Data, Leng(0)) = 0 Then
                    For cnt = 0 To (Leng(0) - 1)
                        SaveFile(0).Write(Data(cnt))
                    Next
                End If
            End If
            SavedDataNum(0) = SavedDataNum(0) + Leng(0)

            If Ch1Only.CheckState = 0 Then
                If (SavedDataNum(1) + Leng(1)) > SmplMaxLeng Then 'Ch2 データが多すぎる場合
                    Leng(1) = SmplMaxLeng - SavedDataNum(1)
                End If
                If Leng(1) Then
                    ReDim Data(Leng(1) - 1)
                    If Tusbadmh_Data_Get(DevId, 1, Data, Leng(1)) = 0 Then
                        For cnt = 0 To (Leng(1) - 1)
                            SaveFile(1).Write(Data(cnt))
                        Next
                    End If
                End If
                SavedDataNum(1) = SavedDataNum(1) + Leng(1)
            End If


            Ch1SampledLeng.Text = CStr(SavedDataNum(0))
            Ch1BufRate.Text = UsableRate(0).ToString("000") & "%"
            Ch2SampledLeng.Text = CStr(SavedDataNum(1))
            Ch2BufRate.Text = UsableRate(1).ToString("000") & "%"

            If Ch1Only.CheckState <> 0 Then
                If (SavedDataNum(0) >= SmplMaxLeng) Then
                    StartStop() '停止
                End If
            Else
                If (SavedDataNum(0) >= SmplMaxLeng) And (SavedDataNum(1) >= SmplMaxLeng) Then
                    StartStop() '停止
                End If
            End If
        End If
    End Sub

    'トリガ選択による有効コントロールの処理
    Private Sub TrgSet()
        ThLevel.Enabled = IIf(TrgSel1.Checked Or TrgSel4.Checked, False, True)
        NCLevel.Enabled = IIf(TrgSel1.Checked Or TrgSel4.Checked, False, True)
        TriggerBtn.Enabled = IIf(TrgSel4.Checked, True, False)
    End Sub

    Private Sub TrgSel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles TrgSel1.CheckedChanged, TrgSel4.CheckedChanged, TrgSel3.CheckedChanged, TrgSel2.CheckedChanged
        TrgSet()
    End Sub

    'トリガボタン押下
    Private Sub TriggerBtn_Click(sender As System.Object, e As System.EventArgs) Handles TriggerBtn.Click
        Dim retErr As Short
        retErr = Tusbadmh_Trigger(DevId)
        If retErr <> 0 Then
            Tusbadmh_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        End If
    End Sub

End Class