﻿Imports System.IO

Public Class MainForm
    Private DevStatus(15) As Boolean ' Device Connection Flag TRUE : connecting
    Private IdDevForm(15) As DevForm ' Device Control Panel Form Object

    Private Sub MainForm_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        Dim DevId As Short

        Timer1.Enabled = False
        For DevId = 0 To 15
            If (IdDevForm(DevId) IsNot Nothing) Then
                If (IdDevForm(DevId).Visible) Then
                    IdDevForm(DevId) = Nothing ' Device Control Panel Unload
                    DevStatus(DevId) = False
                    Tusbadmh_Device_Close(DevId)
                End If
            End If
        Next DevId
    End Sub

    Private Sub MainForm_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim DevId As Short

        Timer1.Interval = 300
        Timer1.Enabled = True

        DevIdSel.SelectedIndex = 0

        'Initialize
        For DevId = 0 To 15
            DevStatus(DevId) = False 'Device is not Connected
        Next DevId
    End Sub

    Private Sub FileConvBtn_Click(sender As System.Object, e As System.EventArgs) Handles FileConvBtn.Click
        Dim ReadFileName As String
        Dim WriteFileName As String
        Dim ReadFile As BinaryReader '読み出しファイルストリーム
        Dim WriteFile As StreamWriter ' 保存ファイルストリーム

        Do
            OpenFileDialog1.FileName = ""
            OpenFileDialog1.Title = "バイナリファイル指定"
            OpenFileDialog1.Filter = "バイナリファイル (*.dat)|*.dat"
            If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                Exit Sub
            End If
        Loop While OpenFileDialog1.FileName = ""
        ReadFileName = OpenFileDialog1.FileName

        Do
            SaveFileDialog1.OverwritePrompt = True
            SaveFileDialog1.FileName = ""
            SaveFileDialog1.Title = "変換先ファイル指定"
            SaveFileDialog1.Filter = "テキスト保存ファイル (*.csv)|*.csv"

            If (SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                Exit Sub
            End If
        Loop While SaveFileDialog1.FileName = ""
        WriteFileName = SaveFileDialog1.FileName

        ReadFile = New BinaryReader(File.OpenRead(ReadFileName)) 'ファイルを開く
        If File.Exists(SaveFileDialog1.FileName) Then '既存ファイルチェック
            File.Delete(SaveFileDialog1.FileName)
        End If
        WriteFile = New StreamWriter(File.OpenWrite(WriteFileName)) 'ファイルを開く

        Dim ClkSelStr() As String = {"200MHz", "20.48MHz", "16.384MHz", "12.8MHz", "1.92MHz", "External"}
        Dim ImpRngStr() As String = {"Unipolar", "Bipolar"}
        Dim TrgSelStr() As String = {"External", "Up edge", "Down edge", "Software"}
        Dim SmpModStr() As String = {"Continuation", "Repeat"}

        WriteFile.WriteLine("Start date time" & "," & System.DateTime.FromBinary(ReadFile.ReadInt64()).ToString()) '日時
        WriteFile.WriteLine("Channel" & "," & ReadFile.ReadByte().ToString()) 'ch
        WriteFile.WriteLine("Clock select" & "," & ClkSelStr(ReadFile.ReadByte())) 'クロック源
        WriteFile.WriteLine("Dividing rate" & "," & ReadFile.ReadByte().ToString()) 'クロック分周率
        WriteFile.WriteLine("Average Cnt" & "," & (2 ^ ReadFile.ReadByte()).ToString()) 'サンプリング平均化乗数
        WriteFile.WriteLine("Input range" & "," & ImpRngStr(ReadFile.ReadByte())) 'レンジ 0:ユニポーラ　1:バイポーラ
        WriteFile.WriteLine("Clock select" & "," & TrgSelStr(ReadFile.ReadByte())) 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
        WriteFile.WriteLine("Trigger threshold" & "," & ReadFile.ReadInt32().ToString()) 'アナログトリガ閾値
        WriteFile.WriteLine("Noise cancel level" & "," & ReadFile.ReadInt32().ToString()) 'ノイズキャンセルレベル
        WriteFile.WriteLine("Sampling mode" & "," & SmpModStr(ReadFile.ReadByte())) '取り込み動作モード 0:連続 1:リピート
        WriteFile.WriteLine("Sampling length per one trigger" & "," & ReadFile.ReadInt32().ToString()) '1トリガ当たりの取り込み長
        WriteFile.WriteLine("Pre trigger length" & "," & ReadFile.ReadInt32().ToString()) 'プレトリガ長

        Try
            Do
                WriteFile.WriteLine(ReadFile.ReadInt32() And &HFFFF)
            Loop
        Catch ex As EndOfStreamException
            If Not (TypeOf ex Is EndOfStreamException) Then
                MessageBox.Show(ex.ToString())
            End If
        End Try

        ReadFile.Close()
        WriteFile.Close()

        MessageBox.Show("変換が終了しました")
    End Sub
    ' Device Control Panel Open
    Private Sub OpenPanel(ByVal Id As Short)
        DevStatus(Id) = True
        IdDevForm(Id) = New DevForm() 'Device Control Panel Form Create
        IdDevForm(Id).SetId(Id)
        IdDevForm(Id).Show() ' Form Show
    End Sub

    Private Sub OpenBtn_Click(sender As System.Object, e As System.EventArgs) Handles OpenBtn.Click
        Dim DevId As Short

        DevId = DevIdSel.SelectedIndex
        If DevStatus(DevId) = False Then ' Device is not connected
            If Tusbadmh_Device_Open(DevId) = 0 Then ' Connection check
                OpenPanel(DevId) '
            End If
        End If
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim DevId As Short

        For DevId = 0 To 15
            If DevStatus(DevId) Then
                If IdDevForm(DevId).Visible = False Then ' Device is not visible
                    Tusbadmh_Device_Close(DevId)
                    DevStatus(DevId) = False
                End If
            End If
        Next DevId
    End Sub

    Private Sub EndAppBtn_Click(sender As System.Object, e As System.EventArgs) Handles EndAppBtn.Click
        Me.Close()
    End Sub
End Class
